local agent_helper = require(AGENT_PATH .. "agent_helper")

AgentAdapter = {
	is_init = false,
	is_login_verify_ing = false,
	login_callback = nil,
	force_logout = false,
	login_verify_url = "http://cls.cp01.youyannet.com/fy1/login_verify.php",
	uid = "",
}

--退出
function PlatformAdapter:OpenExitDialog()
	local format = { title = "退出", message = "退出游戏?", positive = "确定", negative = "取消", }
	self:OpenAlertDialog(format, function (result) if "positive" == result then 
			PlatformBinder:JsonCall("call_agent_exit", "", "", function(result) 
				if "true" == result then
					Log("================ExitExitExitExit")
					AdapterToLua:endGame()
				end
			end)
	end end)
end

-- 初始化
function AgentAdapter:Init()

	if self.is_init then return end
	self.uid = string.gsub((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), self:GetSpid() .. "_", "")
	self.is_init = true
	AgentMs:InitLocalPush()
	PlatformBinder:JsonBind("call_agent_logout", function(arg)
		self:LogoutCallback(arg)
		return true
	end)
end

-- 平台ID
function AgentAdapter:GetSpid()
	return "fy1"
end

-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return self:GetSpid().."_".. self.uid
end

--获得游戏名字
function AgentAdapter:GetGameName()
	return Language.Common.GameName[152]
end


-- 是否有管理中心
function AgentAdapter:IsHasManagerCenter()
	return true
end

--管理中心按钮监听
function AgentAdapter:OpenManagerCenter()
	if self:IsHasManagerCenter() then
		PlatformBinder:JsonCall("call_agent_open_mc", "", "")
	end
end




function AgentAdapter:Login(callback)
	if self.is_login_verify_ing then
		SysMsgCtrl.Instance:ErrorRemind("正在登录验证中，请稍等...", true)
		return
	end
	self.login_callback = callback
	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))--设置登录回调 

end

function AgentAdapter:OnClickBackLogin()
	local callback = function()
		AgentLoginView:OnClickBtnLogin()--重新调出登录界面
    end
    --自己按“返回”切换账号
	PlatformBinder:JsonCall("call_agent_logout", "", "", LUA_CALLBACK(self, callback))
end

function AgentAdapter:LoginCallback(result)--登录后回调

	local json_obj = cjson.decode(result)

	
    local t = {
	     userType = json_obj.userType,
		 timestamp = json_obj.timestamp,
		 serverSign = json_obj.serverSign,
		 openId = json_obj.openId,
     }


     local real_url = string.format("%s?spid=%s&device=%s", self.login_verify_url, self:GetSpid(), tostring(PlatformAdapter.GetPhoneUniqueId()))

	for i,v in pairs(t) do
		real_url=string.format(real_url.."&"..i.."=%s",v)
	end

	local verify_callback = function(url, arg, data, size)
		
		self.is_login_verify_ing = false
		if size <= 0 then
			return
		end
		
		local ret_t = cjson.decode(data)
		if nil == ret_t or 0 ~= ret_t.ret or nil == ret_t.user then
			return
		end
	
		self.uid = ret_t.user.uid
		LoginController.Instance:SetLoginUserData(self:GetPlatName(), ret_t.user)
		self.login_callback(self:GetPlatName())

		agent_helper:ShowFloatButton()
	end

	self.is_login_verify_ing = true
	
	Log("log_real_url====" .. real_url)
	HttpClient:Request(real_url, "", verify_callback)

	return false
	
end

function AgentAdapter:LogoutCallback(result)--注销回调

	self.uid = ""
	if not LoginController.Instance:AgentLoginViewIsOpen() then
		ReStart()
	end
	return true
end

function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)--购买
	if self.uid == "" then
		SysMsgCtrl.Instance:ErrorRemind("uid为空，请联系客服")
		return
	end

	local param_obj = {}
	--设置充值金额，单位“元”
	param_obj.amount=amount
	--服务器id
	param_obj.serverID=server_id
	--角色id
	param_obj.roleID=role_id
	-- 角色名
	param_obj.roleName=role_name
	--商品ID
	param_obj.productID="1"
	--商品名称
	param_obj.productName="元宝"
	-- 商品描述
	param_obj.productDesc="元宝"
	-- 兑换比例
	param_obj.exchange=10
	-- 自定义参数
	param_obj.custom=server_id .. "_" .. self.uid .. "_" .. os.time()

    local role_vo = GameVoManager.Instance:GetMainRoleVo()
	local user_vo = GameVoManager.Instance:GetUserVo()

	if role_vo ~= nil and user_vo ~= nil then
        --服务器名
		param_obj.serverName = user_vo.plat_server_id .. "服-" .. user_vo.plat_server_name
		--角色等级
		param_obj.roleLevel= tostring(role_vo.level) or "0"
	else
		--服务器名
		param_obj.serverName = "_"
		--角色等级
		param_obj.roleLevel= "0"
	end
	Log("AgentAdapter:Pay======" .. cjson.encode(param_obj))

	agent_helper:Pay(cjson.encode(param_obj), nil)
end

-- 创建角色上报
function AgentAdapter:ReportOnCreateRole(role_name)
	self:SubmitInfo(2)
end

-- 进入游戏上报
function AgentAdapter:SubmitRoleData(role_id, role_name, role_level, zone_id, zone_name)
	self:SubmitInfo(1)
end

--  升级上报
function AgentAdapter:ReportOnRoleLevUp(role_id, role_name, role_level, zone_id, zone_name)
	self:SubmitInfo(3)
end


function AgentAdapter:SubmitInfo(type)
	local role_vo = GameVoManager.Instance:GetMainRoleVo()
	local user_vo = GameVoManager.Instance:GetUserVo()

	if role_vo ~= nil and user_vo ~= nil then
		local info = {}
	    --角色id
		info.roleID=tostring(role_vo.role_id)
		-- 角色名
	    info.roleName=role_vo.role_name
	    --角色等级
		info.roleLevel= tostring(role_vo.level) or "0"
		--角色性别
        if 1 == role_vo.role_sex then --男
			info.roleSex="1"
		else -- 女
			info.roleSex="0"
		end
      	--服务器id
	    info.serverID= user_vo.plat_server_id
	     --服务器名
		info.serverName = user_vo.plat_server_id .. "服-" .. user_vo.plat_server_name
		 --游戏方自定义参数，通过回调函数原样返回 
		info.custom = "hello"
		info.sub_type = type
		Log("AgentAdapter:SubmitInfo======" .. cjson.encode(info))
		agent_helper:SubmitExtendData(cjson.encode(info))
	end
end


--是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end
